Meet PaneFlow: Build Stunning Slideshows Visually. No Code Required

Page Vue Component

Page in Framework7 has the same meaning as when you think about web pages. Page is the main component to display and operate content.

Page Vue component represents Framework7's Page.

Page Components

There are following components included:

Page Properties

PropTypeDefaultDescription
<f7-page> properties
namestringPage name
messages-contentbooleanEnable if you use Messages component inside to add required extra styling
page-contentbooleantrueWhen enabled it automatically adds page-content element inside. Useful to disable when you need to use few page-content elements for tabs
tabsbooleanEnable if you use Page as Tabs wrapper
login-screenbooleanEnable if you use Login Screen inside of the page to add required extra styling
no-swipebackbooleanDisables swipeback feature for the current page (affects iOS theme only)
with-subnavbarbooleanEnable if you have Sub Navbar inside of the page
no-navbarbooleanEnable if you use common Navbar layout and need to hide common Navbar (or use another one) for this page (affects iOS theme only)
no-toolbarbooleanEnable if you use common Toolbar/Tabbar layout and need to hide Toolbar (or use another one) for this page
hide-bars-on-scrollbooleanHide Navbar & Toolbar on page scroll
hide-navbar-on-scrollbooleanHide Navbar on page scroll
hide-toolbar-on-scrollbooleanHide Toolbar on page scroll
ptrbooleanEnables Pull To Refresh
ptr-distancenumberCustom pull to refresh trigger distance. By default (if not specified) it is 44px.
ptr-preloaderbooleantrueDisable if you want to use custom pull to refresh preloader element
ptr-bottombooleanfalseEnables pull to refresh from bottom
ptr-mousewheelbooleanfalseEnables pull to refresh with mousewheel (for desktop apps). Works only for PTR top
infinitebooleanEnables Infinite Scroll
infinite-topbooleanEnables infinite scroll on top of the page
infinite-distancenumberDistance from the bottom of page (in px) to trigger infinite scroll event. By default (if not specified), it is 50 (px)
infinite-preloaderbooleantrueDisable if you want to use custom infinite-scroll preloader
<f7-page-content> properties
tabbooleanEnable if you use page-content as Tab
tab-activebooleanEnable if the current tab is active
ptr
ptr-distance
ptr-preloader
ptr-bottom
ptr-mousewheel
infinite
infinite-top
infinite-distance
infinite-preloader
hide-bars-on-scroll
hide-navbar-on-scroll
hide-toolbar-on-scroll
messages-content
login-screen
Same as <f7-page> properties

Page Events

EventDescription
<f7-page> events
page:mountedEvent will be triggered when page with keepAlive route is mounted/attached to DOM
page:initEvent will be triggered after Framework7 initialize required page's components and navbar
page:reinitThis event will be triggered in case of navigating to the page that was already initialized
page:beforeinEvent will be triggered when everything initialized and page is ready to be transitioned into view (into active/current position)
page:afterinEvent will be triggered after page transitioned into view
page:beforeoutEvent will be triggered right before page is going to be transitioned out of view
page:afteroutEvent will be triggered after page transitioned out of view
page:beforeunmountEvent will be triggered when page with keepAlive route is going to be unmounted/detached from DOM
page:beforeremoveEvent will be triggered right before Page will be removed from DOM. This event could be very useful if you need to detach some events / destroy some plugins to free memory. This event won't be triggered for keepAlive routes.
page:tabshowEvent will be triggered when page's parent View as Tab becomes visible
page:tabhideEvent will be triggered when page's parent View as Tab becomes hidden
ptr:pullstartEvent will be triggered when you start to move pull to refresh content
ptr:pullmoveEvent will be triggered during you move pull to refresh content
ptr:pullendEvent will be triggered when you release pull to refresh content
ptr:refreshEvent will be triggered when pull to refresh enters in "refreshing" state
ptr:doneEvent will be triggered after pull to refresh is done and it is back to initial state (after calling pullToRefreshDone method)
infiniteEvent will be triggered when page scroll reaches specified (in data-distance attribute) distance to the bottom.
<f7-page-content> events
tab:showEvent will be triggered when Tab becomes visible/active
tab:hideEvent will be triggered when Tab becomes hidden/inactive
ptr:pullstart
ptr:pullmove
ptr:pullend
ptr:refresh
ptr:done
infinite
Same as <f7-page> events

Page Slots

Page Vue component (<f7-page>) has additional slots for custom elements:

<f7-page>
  <div slot="fixed">Fixed element</div>
  <p>Page content goes here</p>
</f7-page>

<!-- Renders to: -->

<div class="page">
  <div>Fixed element</div>
  <div class="page-content">
    <p>Page content goes here</p>
  </div>
</div>

Examples

Infinite Scroll

infinite-scroll.vue
<template>
  <f7-page
    infinite
    :infinite-distance="50"
    :infinite-preloader="showPreloader"
    @infinite="loadMore"
  >
    <f7-navbar title="Infinite Scroll"></f7-navbar>
    <f7-block-title>Scroll bottom</f7-block-title>
    <f7-list strong-ios outline-ios dividers-ios>
      <f7-list-item
        v-for="(item, index) in items"
        :key="index"
        :title="`Item ${item}`"
      ></f7-list-item>
    </f7-list>
  </f7-page>
</template>
<script>
import { f7Navbar, f7Page, f7BlockTitle, f7List, f7ListItem } from 'framework7-vue';

export default {
  components: {
    f7Navbar,
    f7Page,
    f7BlockTitle,
    f7List,
    f7ListItem,
  },
  data() {
    return {
      items: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20],
      allowInfinite: true,
      showPreloader: true,
    };
  },
  methods: {
    loadMore() {
      const self = this;
      if (!self.allowInfinite) return;
      self.allowInfinite = false;

      setTimeout(() => {
        if (self.items.length >= 200) {
          self.showPreloader = false;
          return;
        }

        const itemsLength = self.items.length;

        for (let i = 1; i <= 20; i += 1) {
          self.items.push(itemsLength + i);
        }

        self.allowInfinite = true;
      }, 1000);
    },
  },
};
</script>

Pull To Refresh

pull-to-refresh.vue
<template>
  <f7-page ptr :ptr-mousewheel="true" @ptr:refresh="loadMore">
    <f7-navbar title="Pull To Refresh"></f7-navbar>
    <f7-list media-list strong-ios dividers-ios outline-ios>
      <f7-list-item
        v-for="(item, index) in items"
        :key="index"
        :title="item.title"
        :subtitle="item.author"
      >
        <template #media>
          <img :src="item.cover" width="44" style="border-radius: 8px" />
        </template>
      </f7-list-item>

      <f7-block-footer>
        <p>
          Just pull page down to let the magic happen.<br />Note that pull-to-refresh feature is
          optimised for touch and native scrolling so it may not work on desktop browser.
        </p>
      </f7-block-footer>
    </f7-list>
  </f7-page>
</template>
<script>
import { f7Navbar, f7Page, f7List, f7ListItem, f7BlockFooter } from 'framework7-vue';

export default {
  components: {
    f7Navbar,
    f7Page,
    f7List,
    f7ListItem,
    f7BlockFooter,
  },
  data() {
    return {
      items: [
        {
          title: 'Yellow Submarine',
          author: 'Beatles',
          cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-1.jpg',
        },
        {
          title: "Don't Stop Me Now",
          author: 'Queen',
          cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-2.jpg',
        },
        {
          title: 'Billie Jean',
          author: 'Michael Jackson',
          cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-3.jpg',
        },
      ],
      songs: ['Yellow Submarine', "Don't Stop Me Now", 'Billie Jean', 'Californication'],
      authors: ['Beatles', 'Queen', 'Michael Jackson', 'Red Hot Chili Peppers'],
    };
  },
  methods: {
    loadMore(done) {
      const self = this;

      setTimeout(() => {
        const picURL = `https://cdn.framework7.io/placeholder/abstract-88x88-${
          Math.floor(Math.random() * 10) + 1
        }.jpg`;
        const song = self.songs[Math.floor(Math.random() * self.songs.length)];
        const author = self.authors[Math.floor(Math.random() * self.authors.length)];

        self.items.push({
          title: song,
          author,
          cover: picURL,
        });

        done();
      }, 1000);
    },
  },
};
</script>

Page Svelte Component
Page in Framework7 has the same meaning as when you think about web pages. Page is the main component to display and operate content.
Page Svelte component represents Framework7's Page.
Page Components
There are following components included:
Page- main page elementPageContent- additional inner page content element
Page Properties
| Prop | Type | Default | Description |
|---|---|---|---|
| <Page> properties | |||
| name | string | Page name | |
| messagesContent | boolean | Enable if you use Messages component inside to add required extra styling | |
| pageContent | boolean | true | When enabled it automatically adds page-content element inside. Useful to disable when you need to use few page-content elements for tabs |
| tabs | boolean | Enable if you use Page as Tabs wrapper | |
| loginScreen | boolean | Enable if you use Login Screen inside of the page to add required extra styling | |
| noSwipeback | boolean | Disables swipeback feature for the current page (affects iOS theme only) | |
| withSubnavbar | boolean | Enable if you have Sub Navbar inside of the page | |
| noNavbar | boolean | Enable if you use common Navbar layout and need to hide common Navbar (or use another one) for this page (affects iOS theme only) | |
| noToolbar | boolean | Enable if you use common Toolbar/Tabbar layout and need to hide Toolbar (or use another one) for this page | |
| hideBarsOnScroll | boolean | Hide Navbar & Toolbar on page scroll | |
| hideNavbarOnScroll | boolean | Hide Navbar on page scroll | |
| hideToolbarOnScroll | boolean | Hide Toolbar on page scroll | |
| ptr | boolean | Enables Pull To Refresh | |
| ptrDistance | number | Custom pull to refresh trigger distance. By default (if not specified) it is 44px. | |
| ptrPreloader | boolean | true | Disable if you want to use custom pull to refresh preloader element |
| ptrBottom | boolean | false | Enables pull to refresh from bottom |
| ptrMousewheel | boolean | false | Enables pull to refresh with mousewheel (for desktop apps). Works only for PTR top |
| infinite | boolean | Enables Infinite Scroll | |
| infiniteTop | boolean | Enables infinite scroll on top of the page | |
| infiniteDistance | number | Distance from the bottom of page (in px) to trigger infinite scroll event. By default (if not specified), it is 50 (px) | |
| infinitePreloader | boolean | true | Disable if you want to use custom infinite-scroll preloader |
| <PageContent> properties | |||
| tab | boolean | Enable if you use page-content as Tab | |
| tabActive | boolean | Enable if the current tab is active | |
| ptr ptrDistance ptrPreloader ptrBottom ptrMousewheel infinite infiniteTop infiniteDistance infinitePreloader hideBarsOnScroll hideNavbarOnScroll hideToolbarOnScroll messagesContent loginScreen | Same as <Page> properties | ||
Page Events
| Event | Description |
|---|---|
| <Page> events | |
| pageMounted | Event will be triggered when page with keepAlive route is mounted/attached to DOM |
| pageInit | Event will be triggered after Framework7 initialize required page's components and navbar |
| pageReinit | This event will be triggered in case of navigating to the page that was already initialized. |
| pageBeforeIn | Event will be triggered when everything initialized and page is ready to be transitioned into view (into active/current position) |
| pageAfterIn | Event will be triggered after page transitioned into view |
| pageBeforeOut | Event will be triggered right before page is going to be transitioned out of view |
| pageAfterOut | Event will be triggered after page transitioned out of view |
| pageBeforeUnmount | Event will be triggered when page with keepAlive route is going to be unmounted/detached from DOM |
| pageBeforeRemove | Event will be triggered right before Page will be removed from DOM. This event could be very useful if you need to detach some events / destroy some plugins to free memory. This event won't be triggered for keepAlive routes. |
| pageTabShow | Event will be triggered when page's parent View as Tab becomes visible |
| pageTabHide | Event will be triggered when page's parent View as Tab becomes hidden |
| ptrPullStart | Event will be triggered when you start to move pull to refresh content |
| ptrPullMove | Event will be triggered during you move pull to refresh content |
| ptrPullEnd | Event will be triggered when you release pull to refresh content |
| ptrRefresh | Event will be triggered when pull to refresh enters in "refreshing" state |
| ptrDone | Event will be triggered after pull to refresh is done and it is back to initial state (after calling pullToRefreshDone method) |
| infinite | Event will be triggered when page scroll reaches specified (in data-distance attribute) distance to the bottom. |
| <PageContent> events | |
| tabShow | Event will be triggered when Tab becomes visible/active |
| tabHide | Event will be triggered when Tab becomes hidden/inactive |
| ptrPullStart ptrPullMove ptrPullEnd ptrRefresh ptrDone infinite | Same as <Page> events |
Page Slots
Page Svelte component (<Page>) has additional slots for custom elements:
default- element will be inserted as a child of "page-content", ifpage-contentprop is enabled (by default)fixed- element will be inserted as a direct child of "page" right before "page-content"
<Page>
<div slot="fixed">Fixed element</div>
<p>Page content goes here</p>
</Page>
<!-- Renders to: -->
<div class="page">
<div>Fixed element</div>
<div class="page-content">
<p>Page content goes here</p>
</div>
</div>Examples
Infinite Scroll
infinite-scroll.svelte
<script>
import { Navbar, Page, BlockTitle, List, ListItem } from 'framework7-svelte';
let items = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20];
let allowInfinite = true;
let showPreloader = true;
function loadMore() {
if (!allowInfinite) return;
allowInfinite = false;
setTimeout(() => {
if (items.length >= 200) {
showPreloader = false;
return;
}
const itemsLength = items.length;
for (let i = 1; i <= 20; i += 1) {
items.push(itemsLength + i);
}
items = items;
allowInfinite = true;
}, 1000);
}
</script>
<Page infinite infiniteDistance={50} infinitePreloader={showPreloader} onInfinite={loadMore}>
<Navbar title="Infinite Scroll" backLink />
<BlockTitle>Scroll bottom</BlockTitle>
<List strong inset dividersIos>
{#each items as item, index (index)}
<ListItem title={`Item ${item}`} />
{/each}
</List>
</Page>
Pull To Refresh
pull-to-refresh.svelte
<script>
import { Navbar, Page, List, ListItem, BlockFooter } from 'framework7-svelte';
let items = [
{
title: 'Yellow Submarine',
author: 'Beatles',
cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-1.jpg',
},
{
title: "Don't Stop Me Now",
author: 'Queen',
cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-2.jpg',
},
{
title: 'Billie Jean',
author: 'Michael Jackson',
cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-3.jpg',
},
];
const songs = ['Yellow Submarine', "Don't Stop Me Now", 'Billie Jean', 'Californication'];
const authors = ['Beatles', 'Queen', 'Michael Jackson', 'Red Hot Chili Peppers'];
function loadMore(done) {
setTimeout(() => {
const picURL = `https://cdn.framework7.io/placeholder/abstract-88x88-${
Math.floor(Math.random() * 10) + 1
}.jpg`;
const song = songs[Math.floor(Math.random() * songs.length)];
const author = authors[Math.floor(Math.random() * authors.length)];
items.push({
title: song,
author,
cover: picURL,
});
items = items;
done();
}, 1000);
}
</script>
<!-- svelte-ignore a11y-missing-attribute -->
<Page ptr ptrMousewheel={true} onPtrRefresh={loadMore}>
<Navbar title="Pull To Refresh" backLink />
<List mediaList strong inset dividersIos>
{#each items as item, index (index)}
<ListItem title={item.title} subtitle={item.author}>
{#snippet media()}
<img src={item.cover} width="44" style="border-radius: 8px" />
{/snippet}
</ListItem>
{/each}
</List>
<BlockFooter>
<p>
Just pull page down to let the magic happen.<br />Note that pull-to-refresh feature is
optimised for touch and native scrolling so it may not work on desktop browser.
</p>
</BlockFooter>
</Page>














Meet our new project:Cladd — A React UI kit for building actual apps

Page React Component

Page in Framework7 has the same meaning as when you think about web pages. Page is the main component to display and operate content.

Page React component represents Framework7's Page.

Page Components

There are following components included:

Page Properties

PropTypeDefaultDescription
<Page> properties
namestringPage name
messagesContentbooleanEnable if you use Messages component inside to add required extra styling
pageContentbooleantrueWhen enabled it automatically adds page-content element inside. Useful to disable when you need to use few page-content elements for tabs
tabsbooleanEnable if you use Page as Tabs wrapper
loginScreenbooleanEnable if you use Login Screen inside of the page to add required extra styling
noSwipebackbooleanDisables swipeback feature for the current page (affects iOS theme only)
withSubnavbarbooleanEnable if you have Sub Navbar inside of the page
noNavbarbooleanEnable if you use common Navbar layout and need to hide common Navbar (or use another one) for this page (affects iOS theme only)
noToolbarbooleanEnable if you use common Toolbar/Tabbar layout and need to hide Toolbar (or use another one) for this page
hideBarsOnScrollbooleanHide Navbar & Toolbar on page scroll
hideNavbarOnScrollbooleanHide Navbar on page scroll
hideToolbarOnScrollbooleanHide Toolbar on page scroll
ptrbooleanEnables Pull To Refresh
ptrDistancenumberCustom pull to refresh trigger distance. By default (if not specified) it is 44px.
ptrPreloaderbooleantrueDisable if you want to use custom pull to refresh preloader element
ptrBottombooleanfalseEnables pull to refresh from bottom
ptrMousewheelbooleanfalseEnables pull to refresh with mousewheel (for desktop apps). Works only for PTR top
infinitebooleanEnables Infinite Scroll
infiniteTopbooleanEnables infinite scroll on top of the page
infiniteDistancenumberDistance from the bottom of page (in px) to trigger infinite scroll event. By default (if not specified), it is 50 (px)
infinitePreloaderbooleantrueDisable if you want to use custom infinite-scroll preloader
<PageContent> properties
tabbooleanEnable if you use page-content as Tab
tabActivebooleanEnable if the current tab is active
ptr
ptrDistance
ptrPreloader
ptrBottom
ptrMousewheel
infinite
infiniteTop
infiniteDistance
infinitePreloader
hideBarsOnScroll
hideNavbarOnScroll
hideToolbarOnScroll
messagesContent
loginScreen
Same as <Page> properties

Page Events

EventDescription
<Page> events
pageMountedEvent will be triggered when page with keepAlive route is mounted/attached to DOM
pageInitEvent will be triggered after Framework7 initialize required page's components and navbar
pageReinitThis event will be triggered in case of navigating to the page that was already initialized.
pageBeforeInEvent will be triggered when everything initialized and page is ready to be transitioned into view (into active/current position)
pageAfterInEvent will be triggered after page transitioned into view
pageBeforeOutEvent will be triggered right before page is going to be transitioned out of view
pageAfterOutEvent will be triggered after page transitioned out of view
pageBeforeUnmountEvent will be triggered when page with keepAlive route is going to be unmounted/detached from DOM
pageBeforeRemoveEvent will be triggered right before Page will be removed from DOM. This event could be very useful if you need to detach some events / destroy some plugins to free memory. This event won't be triggered for keepAlive routes.
pageTabShowEvent will be triggered when page's parent View as Tab becomes visible
pageTabHideEvent will be triggered when page's parent View as Tab becomes hidden
ptrPullStartEvent will be triggered when you start to move pull to refresh content
ptrPullMoveEvent will be triggered during you move pull to refresh content
ptrPullEndEvent will be triggered when you release pull to refresh content
ptrRefreshEvent will be triggered when pull to refresh enters in "refreshing" state
ptrDoneEvent will be triggered after pull to refresh is done and it is back to initial state (after calling pullToRefreshDone method)
infiniteEvent will be triggered when page scroll reaches specified (in data-distance attribute) distance to the bottom.
<PageContent> events
tabShowEvent will be triggered when Tab becomes visible/active
tabHideEvent will be triggered when Tab becomes hidden/inactive
ptrPullStart
ptrPullMove
ptrPullEnd
ptrRefresh
ptrDone
infinite
Same as <Page> events

Page Slots

Page React component (<Page>) has additional slots for custom elements:

<Page>
  <div slot="fixed">Fixed element</div>
  <p>Page content goes here</p>
</Page>

{/* Renders to: */}

<div class="page">
  <div>Fixed element</div>
  <div class="page-content">
    <p>Page content goes here</p>
  </div>
</div>

Examples

Infinite Scroll

infinite-scroll.jsx
import React, { useRef, useState } from 'react';
import { Navbar, Page, BlockTitle, List, ListItem } from 'framework7-react';

export default () => {
  const allowInfinite = useRef(true);
  const [items, setItems] = useState([
    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
  ]);
  const [showPreloader, setShowPreloader] = useState(true);

  const loadMore = () => {
    if (!allowInfinite.current) return;
    allowInfinite.current = false;

    setTimeout(() => {
      if (items.length >= 200) {
        setShowPreloader(false);
        return;
      }

      const itemsLength = items.length;

      for (let i = 1; i <= 20; i += 1) {
        items.push(itemsLength + i);
      }
      allowInfinite.current = true;
      setItems([...items]);
    }, 1000);
  };

  return (
    <Page infinite infiniteDistance={50} infinitePreloader={showPreloader} onInfinite={loadMore}>
      <Navbar title="Infinite Scroll" backLink></Navbar>
      <BlockTitle>Scroll bottom</BlockTitle>
      <List strong inset dividersIos>
        {items.map((item, index) => (
          <ListItem title={`Item ${item}`} key={index}></ListItem>
        ))}
      </List>
    </Page>
  );
};

Pull To Refresh

pull-to-refresh.jsx
import React, { useState } from 'react';
import { Navbar, Page, List, ListItem, BlockFooter } from 'framework7-react';

export default () => {
  const songs = ['Yellow Submarine', "Don't Stop Me Now", 'Billie Jean', 'Californication'];
  const authors = ['Beatles', 'Queen', 'Michael Jackson', 'Red Hot Chili Peppers'];
  const [items, setItems] = useState([
    {
      title: 'Yellow Submarine',
      author: 'Beatles',
      cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-1.jpg',
    },
    {
      title: "Don't Stop Me Now",
      author: 'Queen',
      cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-2.jpg',
    },
    {
      title: 'Billie Jean',
      author: 'Michael Jackson',
      cover: 'https://cdn.framework7.io/placeholder/abstract-88x88-3.jpg',
    },
  ]);
  const loadMore = (done) => {
    setTimeout(() => {
      const picURL = `https://cdn.framework7.io/placeholder/abstract-88x88-${
        Math.floor(Math.random() * 10) + 1
      }.jpg`;
      const song = songs[Math.floor(Math.random() * songs.length)];
      const author = authors[Math.floor(Math.random() * authors.length)];
      items.push({ title: song, author, cover: picURL });
      setItems([...items]);

      done();
    }, 1000);
  };
  return (
    <Page ptr ptrMousewheel={true} onPtrRefresh={loadMore}>
      <Navbar title="Pull To Refresh" backLink></Navbar>
      <List mediaList strong inset dividersIos>
        {items.map((item, index) => (
          <ListItem key={index} title={item.title} subtitle={item.author}>
            <img slot="media" src={item.cover} width="44" style={{ borderRadius: '8px' }} />
          </ListItem>
        ))}
        <BlockFooter>
          <p>
            Just pull page down to let the magic happen.
            <br />
            Note that pull-to-refresh feature is optimised for touch and native scrolling so it may
            not work on desktop browser.
          </p>
        </BlockFooter>
      </List>
    </Page>
  );
};